Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_fromXMLLight.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_fromXMLLight.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_fromXMLLight.cpp	(revision 88)
@@ -0,0 +1,245 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+#include "Common/include/FromString.h"
+#include <fstream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  using namespace XMLUtils;
+
+#undef  FUNCTION
+#define FUNCTION "Instance::fromXMLLight"
+  void Instance::fromXMLLight (XML_t * xml,
+                               attribute_t         id,
+                               list_parameters_t * list_parameters,
+                               list_links_t      * list_links,
+                               list_components_t * list_components)
+  {
+
+    XMLLightVector<XML_t> vect = xml->getNodes(); 
+    
+    for (uint32_t i=0; i<vect.size(); ++i)
+      {
+        XML_t * child = vect[i];
+
+        std::string child_name = child->getName();
+
+        //--------------------------------------------
+        // Child : Parameter
+        //--------------------------------------------
+        if (child_name == "parameter")
+          {
+            // Is a parameter
+            testSingleton  (child,true);        
+            
+            attributes_t attributes = child->getAttributes();
+            attribute_t  value_name = getAttribute(child,attributes,"name" );
+            attribute_t  value      = getAttribute(child,attributes,"value");
+            
+            testAttributesEmpty(child,attributes);
+
+            // Test the parameter :
+            //   * name is correct
+            //   * value is correct
+            test (value_name, value);
+            
+            // Insert in array
+            Parameter_affectation * param = new Parameter_affectation(value_name, // type
+                                                                      value);
+            
+            // insert parameter
+            (*list_parameters)[param->_name] = param;
+          }
+        //--------------------------------------------
+        // Child : Link
+        //--------------------------------------------
+        else
+        if (child_name == "link")
+          {
+            // Is a parameter
+            testSingleton  (child,true);        
+            
+            attributes_t attributes = child->getAttributes();
+            attribute_t  value_name = getAttribute(child,attributes,"name");
+            
+            // Test, must have src or dest (or twice)
+            bool have_src  = child->containsAttribute("src" );
+            bool have_dest = child->containsAttribute("dest");
+            if (not have_src  and
+                not have_dest)
+              throw ERRORMORPHEO(FUNCTION,toString(_("Syntax error, node \"link\" must have one or twince of this attributes : src, dest\n")));
+            
+            attribute_t  value_src  = (have_src )?getAttribute(child,attributes,"src" ):id;
+            attribute_t  value_dest = (have_dest)?getAttribute(child,attributes,"dest"):id;
+
+            testAttributesEmpty(child,attributes);
+            
+            // Test the link :
+            //   * name is correct
+            //   * if not have_src , test if src  is correct
+            //   * if not have_dest, test if dest is correct
+            test (value_name,
+                  xml->getName(),
+                  not have_src,
+                  not have_dest);
+
+            // Create a new link
+            {
+              Link_affectation * link = new Link_affectation(value_name, // type
+                                                             value_src,
+                                                             value_dest);
+              
+              // Test if this id is previously used
+              if (((*list_links)[value_name]).find(value_src) != ((*list_links)[value_name]).end())
+                throw ERRORMORPHEO(FUNCTION,toString(_("A Link \"%s\" with the source \"%s\" is previously declared.\n"),value_name.c_str(),value_src.c_str()));
+              
+              ((*list_links)[value_name])[value_src] = link;
+            }
+          }
+        //--------------------------------------------
+        // Child : Timing
+        //--------------------------------------------
+        else
+        if (child_name == "timing")
+          {
+            // Notation :
+            //     <timing type="5" operation="8" latence="2"  delay="1" />
+            // 
+            // is equivalent at :
+            //     <type id="5" >
+            //       <operation id="8" >
+            //         <parameter  name="delay"   value="1" />
+            //         <parameter  name="latence" value="2" />
+            //       </operation>
+            //     </type>
+
+            // Is a parameter
+            testSingleton  (child,true);        
+            
+            attributes_t attributes      = child->getAttributes();
+            attribute_t  value_type      = getAttribute(child,attributes,"type");
+            bool         have_operation  = (child->containsAttribute("operation"));
+            attribute_t  value_operation ;
+            attribute_t  value_latence   = (child->containsAttribute("latence"  ))?getAttribute(child,attributes,"latence"  ):"1";
+            attribute_t  value_delay     = (child->containsAttribute("delay"    ))?getAttribute(child,attributes,"delay"    ):"1";
+
+            {
+              // Find component "type", if don't exist : create
+              if (((*list_components)["type"]).find(value_type) == ((*list_components)["type"]).end())
+                {
+                  // Create instance
+                  Instance_component * param = new Instance_component("type", // type
+                                                                      value_type);
+                  ((*list_components)["type"])[value_type] = param;
+                }
+
+              list_components_t * list_type = ((*list_components)["type"])[value_type]->_list_components;
+
+              // Find component "operation", if exist : error, else create
+
+              bool         stop            = false;
+              Toperation_t operation       = 0;
+              attribute_t  value_operation = (have_operation)?getAttribute(child,attributes,"operation"):toString(operation);
+
+              while (not stop)
+                {
+                  if (((*list_type)["operation"]).find(value_operation) != ((*list_type)["operation"]).end())
+                    throw ERRORMORPHEO(FUNCTION,toString(_("A Component \"%s\" with id \"%s\" is previously declared.\n"),"operation",value_operation.c_str()));
+                  else
+                    {
+                      // Create instance
+                      Instance_component * param = new Instance_component("operation", // type
+                                                                          value_operation);
+                      ((*list_type)["operation"])[value_operation] = param;
+                    }
+
+                  list_parameters_t * list_operation = ((*list_type)["operation"])[value_operation]->_list_parameters;
+                  
+                  // insert parameter "latence" and "delay"
+                  Parameter_affectation * param_latence = new Parameter_affectation("latence",
+                                                                                    value_latence);
+                  Parameter_affectation * param_delay   = new Parameter_affectation("delay",
+                                                                                    value_delay);            
+                  
+                  (*list_operation)["latence"] = param_latence;
+                  (*list_operation)["delay"  ] = param_delay  ;
+
+                  operation ++;
+                  value_operation = toString(operation);
+                  stop = have_operation or (operation == MAX_OPERATION);
+                };
+              
+            }
+
+            testAttributesEmpty(child,attributes);
+          }
+        //--------------------------------------------
+        // Child : Other (node)
+        //--------------------------------------------
+        else
+          {
+            testSingleton  (child,false);        
+            
+            attributes_t attributes = child->getAttributes();
+            attribute_t  value_id   = getAttribute(child,attributes,"id");
+            attribute_t  value_type = child->getName();
+            
+            testAttributesEmpty(child,attributes);
+            
+            // Create a new component
+            {
+              Instance_component * param = new Instance_component(value_type, // type
+                                                                  value_id);
+              
+//            log_printf(TRACE,Configuration,FUNCTION,"%s.%s",value_type.c_str(),value_id.c_str());
+//            log_printf(TRACE,Configuration,FUNCTION,"  * %d",((*list_components)[value_type]).size());
+              
+              // Test if this id is previously used
+              if (((*list_components)[value_type]).find(value_id) != ((*list_components)[value_type]).end())
+                throw ERRORMORPHEO(FUNCTION,toString(_("A Component \"%s\" with id \"%s\" is previously declared.\n"),value_type.c_str(),value_id.c_str()));
+              
+              ((*list_components)[value_type])[value_id] = param;
+            }
+            
+            // Test if counter is an parameters
+            {
+              std::string name_counter = "nb_"+value_type;
+//            std::cout << name_counter << std::endl;
+              
+              if (list_parameters->find(name_counter) == list_parameters->end())
+                {
+                  // Scearch all occurante of this type
+                  uint32_t nb_counter = xml->getNodes(value_type).size();
+//                std::cout << "  * " << nb_counter << std::endl;
+                  
+                  // Insert in array
+                  Parameter_affectation * param = new Parameter_affectation(name_counter, // type
+                                                                            toString(nb_counter));
+                  
+                  // insert parameter
+                  (*list_parameters)[name_counter] = param;
+                }
+            }
+            
+            // Recursive function
+            fromXMLLight (child,
+                          ((id=="")?value_id:(id+"."+value_id)), // construction of identificator
+                          ((*list_components)[value_type])[value_id]->_list_parameters,
+//                        ((*list_components)[value_type])[value_id]->_list_links,
+                          list_links,
+                          ((*list_components)[value_type])[value_id]->_list_components);
+          }
+      }
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getLink.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getLink.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getLink.cpp	(revision 88)
@@ -0,0 +1,91 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::getLink"
+  std::vector<std::string> Instance::getLink (const char * name, ...)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::string src = "";
+    std::string dest;
+
+    // Create src id
+    {
+      va_list args;
+      va_start(args, name);
+
+      std::string tmp;
+      while ((tmp = va_arg(args,const char *)) != "")
+        {
+          if (src == "")
+            src = tmp;
+          else
+            src += "." + tmp;
+        }
+      va_end(args);
+    }
+
+    // Find link
+    bool find = true;
+    
+    {
+      // find link
+      list_links_t::iterator it1=_list_links->find(name);
+      
+      if (it1 == _list_links->end())
+        {
+//        log_printf(INFO,Configuration,FUNCTION,_("Link       \"%s\" is not define, don't link."),name);
+          find = false;
+        }
+      else
+        {
+          // Find src
+          list_link_t::iterator it2=it1->second.find(src);
+          
+          if (it2 == it1->second.end())
+            {
+//            log_printf(INFO,Configuration,FUNCTION,_("Link       \"%s[%s]\" is not define, don't link."),name,src.c_str());
+              find = false;
+            }
+          else
+            {
+              if (it2->second->_use)
+                throw ERRORMORPHEO(FUNCTION,toString(_("Link \"%s[%s]\" is already used.\n"),name,src.c_str()));
+
+              dest = it2->second->_dest;
+              it2->second->_use = true; // now, this parameters is use
+            }
+        }
+    }
+
+    std::vector<std::string> _return;
+    if (find)
+      {
+        _return = link2array(dest);
+        log_printf(INFO,Configuration,FUNCTION,_("Link       \"%s[%s]\"= %s."),name,src.c_str(),dest.c_str());
+      }
+    else
+      {
+        _return.clear();
+        log_printf(INFO,Configuration,FUNCTION,_("Link       \"%s[%s]\" not find."),name,src.c_str());
+      }
+
+    log_end(Configuration,FUNCTION);
+
+    return _return;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getName.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getName.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getName.cpp	(revision 88)
@@ -0,0 +1,29 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::getName"
+  std::string Instance::getName (void)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::string _return = _name;
+
+    log_end(Configuration,FUNCTION);
+
+    return _return;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getParam.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getParam.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_getParam.cpp	(revision 88)
@@ -0,0 +1,96 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::getParam"
+  std::string Instance::getParam (const char * name, ...)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::string value = "";
+    
+    // Go to the good component
+    list_parameters_t * list_parameters = _list_parameters;
+    list_components_t * list_components = _list_components;
+    
+    {
+      va_list args;
+      va_start(args, name);
+
+      std::string component = "";
+      std::string id = "";
+      std::string tmp;
+      while (((tmp = va_arg(args,const char *)) != "") and
+             (value  == ""))
+        {
+          // 2 string :
+          //   * first  : component
+          //   * second : id
+
+          component = tmp;
+
+          if ((tmp = va_arg(args,const char *)) == "")
+            throw ERRORMORPHEO(FUNCTION,_("Must have two name : first is the component's name, second is the identification\n"));
+          id = tmp;
+
+          list_instances_t::iterator it=((*list_components)[component]).find(id);
+          
+          if (it == ((*list_components)[component]).end())
+            {
+              log_printf(INFO,Configuration,FUNCTION,_("Component \"%s[%s]\" is not define, take default value for parameter \"%s\"."),component.c_str(),id.c_str(),name);
+
+              value = _generator->getParam(name)->_default;
+            }
+          else
+            {
+              list_parameters = it->second->_list_parameters;
+              list_components = it->second->_list_components;
+            }
+        }
+
+      if (value == "")
+        {
+          // no default value : component is find
+          
+          // Test if parameters exist
+//           std::map<std::string, Parameter_affectation *>
+          list_parameters_t::iterator it=(*list_parameters).find(name);
+          if (it == (*list_parameters).end())
+            {
+              log_printf(INFO,Configuration,FUNCTION,_("Component \"%s[%s]\" is define, but parameter \"%s\" is not define. Take default value."),component.c_str(),id.c_str(),name);
+
+              value = _generator->getParam(name)->_default;
+            }
+          else
+            {
+              if (it->second->_use)
+                throw ERRORMORPHEO(FUNCTION,toString(_("Parameter \"%s\" is already used.\n"),name));
+
+              value = it->second->_value;
+              it->second->_use = true; // now, this parameters is use
+            }
+        }
+
+      va_end(args);
+    }
+    
+    log_printf(INFO,Configuration,FUNCTION,_("Parameters \"%s\" = %s."),name,value.c_str());
+
+    log_end(Configuration,FUNCTION);
+
+    return value;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_link2array.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_link2array.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_link2array.cpp	(revision 88)
@@ -0,0 +1,42 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::link2array"
+  std::vector<std::string> Instance::link2array (std::string str)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::vector<std::string> _return;
+
+    size_t begin=0;
+    size_t end  =0;
+    
+    do
+      {
+        end = str.find_first_of(".",begin); // "." is the separator
+        
+        _return.push_back(str.substr(begin, end-begin));
+        
+        begin = end+1; // next index
+      }
+    while (end!=std::string::npos);
+
+    log_end(Configuration,FUNCTION);
+
+    return _return;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_print.cpp	(revision 88)
@@ -0,0 +1,39 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::print"
+  std::string Instance::print (uint32_t depth)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::string _return = (toXML()).get_body(depth);
+
+    log_end(Configuration,FUNCTION);
+    return _return;
+  };
+  
+#undef  FUNCTION
+#define FUNCTION "Instance::operator<<"
+  std::ostream& operator<< (std::ostream& output,
+			    morpheo::behavioural::configuration::Instance & x)
+  {
+    log_begin(Configuration,FUNCTION);
+    output << x.print(0);
+    log_end(Configuration,FUNCTION);
+    return output;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_test.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_test.cpp	(revision 88)
@@ -0,0 +1,107 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::test"
+  void Instance::test (std::string type,
+                       std::string value)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    // Test the parameter :
+    //   * name is correct
+    //   * value is correct
+    
+    _generator->test(type, value);
+    
+    log_end(Configuration,FUNCTION);
+  }
+
+#undef  FUNCTION
+#define FUNCTION "Instance::test"
+  void Instance::test (std::string type,
+                       std::string father_name,
+                       bool        father_is_src,
+                       bool        father_is_dest)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    //   * name is correct
+    //   * if not have_src , test if src  is correct
+    //   * if not have_dest, test if dest is correct
+    _generator->test(type,
+                     father_name,
+                     father_is_src,
+                     father_is_dest);
+    
+    log_end(Configuration,FUNCTION);
+  }
+
+#undef  FUNCTION
+#define FUNCTION "Instance::test"
+
+  void Instance::test (std::string link,
+                       std::vector<std::string> & vect,
+                       uint32_t nb_elt)
+  {
+    log_begin(Configuration,FUNCTION);
+    
+    if (vect.size() == 0)
+      for (uint32_t i=0; i<nb_elt; ++i)
+        vect.push_back("0"); // default to link
+    else
+      if (vect.size() != nb_elt)
+        throw ERRORMORPHEO(FUNCTION,toString(_("The destination of link \"%s\" must an index on %d elements.\n"),link.c_str(),nb_elt));
+
+    log_end(Configuration,FUNCTION);
+  }
+
+  /*
+#undef  FUNCTION
+#define FUNCTION "Instance::test"
+  void Instance::test (std::string component,
+                       uint32_t    nb_component)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    test (component,nb_component,_list_components);
+
+    log_end(Configuration,FUNCTION);
+  }
+
+#undef  FUNCTION
+#define FUNCTION "Instance::test"
+  void Instance::test (std::string         component,
+                       uint32_t            nb_component,
+                       list_components_t * list_components)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    // ........................
+
+
+    for (list_components_t::iterator it1=list_components->begin();
+         it1!=list_components->end();
+         ++it1)
+      for (list_instances_t::iterator it2=it1->second.begin();
+           it2!=it1->second.end();
+           ++it2)
+      test (component,nb_component,it2->second->_list_components);
+    
+    log_end(Configuration,FUNCTION);
+  }
+  */  
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_test_use.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_test_use.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_test_use.cpp	(revision 88)
@@ -0,0 +1,99 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::test_use"
+  void Instance::test_use (void)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::vector<std::string> list_not_use;
+
+    for (list_links_t::iterator it1 = _list_links->begin();
+         it1 != _list_links->end();
+         ++it1)
+      for (list_link_t::iterator it2 = it1->second.begin();
+           it2 != it1->second.end();
+           ++it2)
+        {
+          Link_affectation * link = it2->second;
+          if (link->_use == false)
+            {
+              std::string str = link->_name;
+
+              list_not_use.push_back(toString(_("Link \"%s[%s]\""),str.c_str(),link->_src.c_str()));
+            }
+        }
+
+    test_use("",
+             _list_parameters,
+             _list_components,
+             list_not_use);
+
+    if (list_not_use.size() != 0)
+      {
+        std::string str = "";
+        for (uint32_t i=0; i<list_not_use.size(); ++i)
+          {
+            str += list_not_use[i]+_("\n");
+          }
+        
+        throw ERRORMORPHEO(FUNCTION,toString(_("A lot of parameters is not used :\n%s"),str.c_str()));
+      }
+
+    log_end(Configuration,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Instance::test_use"
+  void Instance::test_use (std::string name,
+                           list_parameters_t * list_parameters,
+                           list_components_t * list_components,
+                           std::vector<std::string> & list_not_use)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    for (list_parameters_t::iterator it = list_parameters->begin();
+         it != list_parameters->end();
+         ++it)
+      {
+        Parameter_affectation * param = it->second;
+        if (param->_use == false)
+          {
+            std::string str = ((name == "")?"":(name+".")) + param->_name;
+
+            list_not_use.push_back(toString(_("Parameter \"%s\""),str.c_str()));
+          }
+      }
+
+    for (list_components_t::iterator it1 = list_components->begin();
+         it1 != list_components->end();
+         ++it1)
+      for (list_instances_t::iterator it2 = it1->second.begin();
+           it2 != it1->second.end();
+           ++it2)
+        {
+          Instance_component * instance = it2->second;
+
+          test_use(((name == "")?"":(name+"."))+instance->_name+"["+instance->_id+"]",
+                   instance->_list_parameters,
+                   instance->_list_components,
+                   list_not_use);
+        }
+
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_toFile.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_toFile.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_toFile.cpp	(revision 88)
@@ -0,0 +1,27 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::toFile"
+  void Instance::toFile (std::string dirname)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    (toXML()).generate_file(dirname);
+
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_toXML.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_toXML.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_toXML.cpp	(revision 88)
@@ -0,0 +1,53 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::toXML"
+  XML Instance::toXML (void)
+  {
+    XML xml (basename(_filename.c_str()));
+    xml.filename_extension("");
+    
+    xml.balise_open_begin("core");
+    xml.attribut("name",_name);
+    xml.balise_open_end  ();
+
+    for (list_parameters_t::iterator it = _list_parameters->begin();
+         it != _list_parameters->end();
+         ++it)
+      xml.insert_XML(it->second->toXML(),1);
+
+    for (list_links_t::iterator it1 = _list_links->begin();
+         it1 != _list_links->end();
+         ++it1)
+      for (list_link_t::iterator it2 = it1->second.begin();
+           it2 != it1->second.end();
+           ++it2)
+        xml.insert_XML(it2->second->toXML(),1);
+    
+    for (list_components_t::iterator it1 = _list_components->begin();
+         it1 != _list_components->end();
+         ++it1)
+      for (list_instances_t::iterator it2 = it1->second.begin();
+           it2 != it1->second.end();
+           ++it2)
+      xml.insert_XML(it2->second->toXML(),1);
+
+    xml.balise_close();
+
+    return xml;
+  }
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Link_affectation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Link_affectation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Link_affectation.cpp	(revision 88)
@@ -0,0 +1,41 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Link_affectation.h"
+#include "Behavioural/include/Stat_binary_tree.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Link_affectation::Link_affectation"
+  Link_affectation::Link_affectation  (std::string name,
+                                       std::string src ,
+                                       std::string dest):
+    _name (name),
+    _src  (src ),
+    _dest (dest)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    _use = false;
+
+    log_end(Configuration,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Link_affectation::~Link_affectation"
+  Link_affectation::~Link_affectation () 
+  {
+    log_begin(Configuration,FUNCTION);
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
